package edu.brynmawr.starter;

import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.lang.ref.WeakReference;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Date;
import java.util.concurrent.Executor;
import java.util.concurrent.RejectedExecutionException;

public class MainActivity extends AppCompatActivity {

    public static final int MAT_BY_LAUNCHER = 17448;
    public static final int MAT_BY_SOUNDER = 17449;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }

    public boolean onCreateOptionsMenu(Menu menu){

        {
            MenuItem edit_item = menu.add(0, MAT_BY_LAUNCHER, 1, "Get data");
            edit_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_ALWAYS);
        }
        {
            MenuItem edit_item = menu.add(0, MAT_BY_SOUNDER, 1, "Waiting");
            edit_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_ALWAYS);
        }

        /*
        MenuItem delete_item = menu.add(0, 17235, 2, "Geoff");
        delete_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_NEVER);
        MenuItem geoff2 = menu.add(1, 17236, 3, "Geoff2");
        geoff2.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_ALWAYS);
*/
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        Log.i("THISS", "Clicked on menu item " + id);
        if (id == MAT_BY_LAUNCHER ) {
            //Toast.makeText(this, "BY LAUNCHER", Toast.LENGTH_LONG).show();
            final String[][] ee = {
                    {"ActionPageSize", "1"},
                    {"ActionPageNo", "1"},
            };
            //String res = webInvokeJSON("http://comet.cs.brynmawr.edu/~gtowell/380/rocket/sounders.php", ee);

            Executor exec = new Executor() {
                @Override
                public void execute(Runnable command) {
                    new Thread(command).start();
                }
            };

            try {
                exec.execute(new GetLaunchersRunnerV3());
            }
            catch (RejectedExecutionException | NullPointerException exception) {
                Log.e("THISS", "Thread problem", exception);
            }

            return true;
        }
        if (id == MAT_BY_SOUNDER) {
            final int delay = 10;
            final RelativeLayout rl = findViewById(R.id.mainlayout);
            final TextView tv = new TextView(this);
            tv.setText(""+delay);
            tv.setGravity(Gravity.CENTER);
            tv.setBackgroundColor(Color.MAGENTA);
            tv.setTextSize(128);
            tv.setTypeface(null, Typeface.BOLD);
            ViewGroup.LayoutParams lpp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
            rl.addView(tv, lpp);
            tv.setRotation(0);
            tv.animate().rotation(2880).setDuration(delay*1000).setListener(new AnimatorListenerAdapter() {
                @Override
                public void onAnimationEnd(Animator animation) {
                    super.onAnimationEnd(animation);
                }
            });
            Executor exec = new Executor() {
                @Override
                public void execute(Runnable command) {
                    new Thread(command).start();
                }
            };

            try {
                exec.execute(new Runnable() {
                    @Override
                    public void run() {
                        for (int i=delay; i>=0; i--) {
                            try {
                                Thread.sleep(1000);
                            } catch (Exception ee) {
                            }
                            final int j=i;
                            new Handler(Looper.getMainLooper()).post(new Runnable() {
                                @Override
                                public void run() {
                                    if (j>0)
                                        tv.setText(""+j);
                                    else
                                        rl.removeView(tv);
                                }
                            });
                        }
                    }
                });
            }
            catch (RejectedExecutionException | NullPointerException exception) {
                Log.e("THISS", "Thread problem", exception);
            }

            return true;


        }

        return true;
    }

    String webInvokeJSON(String urlString, String[][] args)
    {
        System.setProperty("http.keepAlive", "false");
        Log.d("THISS", "invoker " + urlString);
        Date sdate = new Date();
        HttpURLConnection conn;
        URL myUrl;
        StringBuilder response = new StringBuilder();
        try
        {
            myUrl = new URL(urlString);
            conn = (HttpURLConnection) myUrl.openConnection();
            conn.setReadTimeout(6000);
            conn.setConnectTimeout(5000);
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Content-Type", "application/json; utf-8");
            conn.setRequestProperty("Accept", "application/json");
            //conn.setDoInput(true);
            conn.setDoOutput(true);
            conn.setRequestProperty("Connection", "close");
            conn.connect();

            StringBuilder postData = new StringBuilder();
            postData.append("{");
            boolean firstTime = true;
            for (String[] ap : args)
            {
                //Log.d("THISS", "POST PARAM: " + ap[0] + ">><<" + ap[1] + ">>");
                if (firstTime)
                {
                    firstTime = false;
                } else
                {
                    postData.append(", ");
                }
                postData.append("\"").append(ap[0]).append("\"");
                postData.append(":");
                postData.append("\"").append(ap[1]).append("\"");
            }
            postData.append("}");
            Log.i("THISS", "Uploading " + postData.toString());


            OutputStream os = conn.getOutputStream();
            byte[] input = postData.toString().getBytes(StandardCharsets.UTF_8);
            os.write(input, 0, input.length);
            os.close();
            Date eDate = new Date();
            Log.i("THISS", "WEB  POST " + (eDate.getTime() - sdate.getTime()));

            int status = conn.getResponseCode();
            Log.e("THISS", "Status " + status);
            if (conn.getResponseCode() < 299)
            {
                InputStream inputStream;
                inputStream = conn.getInputStream();
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream, StandardCharsets.UTF_8));
                String line;
                while ((line = bufferedReader.readLine()) != null)
                {
                    response.append(line);
                }
                bufferedReader.close();
                inputStream.close();
                conn.disconnect();
                os.close();
                eDate = new Date();
                Log.i("THISS", "WEB  READ " + (eDate.getTime() - sdate.getTime()));
            }
            else
            {
                Log.e("THISS", "Response code indicates failure " + status);
                Thread.dumpStack();
                Log.i("THISS", "Was trying " + urlString + " with " +  postData.toString());
                return null;
            }
        }
        catch (Exception ee)
        {
            Log.e("THISS", ee.toString(), ee);
            ee.printStackTrace();
            return null;
        }
        Log.i("UURL NEWwww", response.toString());
        return response.toString();
    }


    private class GetLaunchersRunner implements Runnable {

        @Override
        public void run() {
            final String[][] ee = {
                    {"ActionPageNo", "1"},
            };
            String res = webInvokeJSON("http://comet.cs.brynmawr.edu/~gtowell/380/rocket/sounders.php", ee);
            Log.i("THISS", res);
        }
    }

    private class GetLaunchersRunnerV2 implements Runnable {

        @Override
        public void run() {
            final String[][] ee = {
                    {"ActionPageNo", "1"},
            };
            String res = webInvokeJSON("http://comet.cs.brynmawr.edu/~gtowell/380/rocket/sounders.php", ee);
            TextView tv = (TextView)MainActivity.this.findViewById(R.id.textview);
            tv.setText(res);

        }
    }

    private class GetLaunchersRunnerV3 implements Runnable {

        @Override
        public void run() {
            final String[][] ee = {
                    {"ActionPageNo", "1"},
            };
            String res = webInvokeJSON("http://comet.cs.brynmawr.edu/~gtowell/380/rocket/sounders.php", ee);

            new Handler(Looper.getMainLooper()).post(new Runnable()
            {
                @Override
                public void run()
                {
                    TextView tv = (TextView)MainActivity.this.findViewById(R.id.textview);
                    tv.setText(res);
                }
            });

        }
    }

}